<?php
/*
This file is part of Thomas Bley's moregroupware webmail2/calendar2/admin2 module. (tb-mgw)

More information:
-----------------

Simple Groupware Solutions Thomas Bley
Fichtenstr. 23
Germany, 85640 Putzbrunn

Contact:
--------

info@simple-groupware.de

http://www.simple-groupware.de


Copyright 2002-2003 Thomas Bley
tb-mgw is distributed under the terms of the GNU General Public License 

tb-mgw is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

tb-mgw is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with tb-mgw; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Imap_mailbox
// Moregroupware.org


/**
 * imap_mailbox.php
 *
 * Copyright (c) 1999-2002 The SquirrelMail Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * This impliments all functions that manipulate mailboxes
 *
 * $Id: imap_mailbox.php,v 1.10 2003/10/04 05:22:15 emailtotom Exp $
 */

global $boxesnew;

function decodeBASE64($s) {
	$B64Values = array(
		"A" =>  0, "B" =>  1, "C" =>  2, "D" =>  3, "E" =>  4, "F" =>  5,
		"G" =>  6, "H" =>  7, "I" =>  8, "J" =>  9, "K" => 10, "L" => 11,
		"M" => 12, "N" => 13, "O" => 14, "P" => 15, "Q" => 16, "R" => 17,
		"S" => 18, "T" => 19, "U" => 20, "V" => 21, "W" => 22, "X" => 23,
		"Y" => 24, "Z" => 25,
		"a" => 26, "b" => 27, "c" => 28, "d" => 29, "e" => 30, "f" => 31,
		"g" => 32, "h" => 33, "i" => 34, "j" => 35, "k" => 36, "l" => 37,
		"m" => 38, "n" => 39, "o" => 40, "p" => 41, "q" => 42, "r" => 43,
		"s" => 44, "t" => 45, "u" => 46, "v" => 47, "w" => 48, "x" => 49,
		"y" => 50, "z" => 51,
		"0" => 52, "1" => 53, "2" => 54, "3" => 55, "4" => 56, "5" => 57,
		"6" => 58, "7" => 59, "8" => 60, "9" => 61, "+" => 62, "," => 63
	);
	$p = 0;
	$d = '';
	$unicodeNullByteToggle = 0;
	for ($i = 0; $i < strlen($s); $i++) {
		$c = $s[$i];
		if ($p == 0) {
			$t = $B64Values[$c];
			$p = 1;
		} elseif ($p == 1) {
			if ($unicodeNullByteToggle) {
				$d = $d . chr(($t << 2) + (($B64Values[$c] & 48) >> 4));
				$unicodeNullByteToggle = 0;
			} else {
				$unicodeNullByteToggle = 1;
			}
			$t = ($B64Values[$c] & 15);
			$p = 2;
		} elseif ($p == 2) {
			if ($unicodeNullByteToggle) {
				$d = $d . chr(($t << 4) + (($B64Values[$c] & 60) >> 2));
				$unicodeNullByteToggle = 0;
			} else {
				$unicodeNullByteToggle = 1;
			}
			$t = ($B64Values[$c] & 3);
			$p = 3;
		} elseif ($p == 3) {
			if ($unicodeNullByteToggle) {
				$d = $d . chr(($t << 6) + $B64Values[$c]);
				$unicodeNullByteToggle = 0;
			} else {
				$unicodeNullByteToggle = 1;
			}
			$t = ($B64Values[$c] & 3);
			$p = 0;
		}
	}
	return $d;
}

function imap_utf7_decode_local($s) {
	$b64_s = '';
	$iso_8859_1_s = '';
	for ($i = 0; $i < strlen($s); $i++) {
		$c = $s[$i];
		if (strlen($b64_s) > 0) {
			if ($c == '-') {
				if ($b64_s == '&') {
					$iso_8859_1_s = $iso_8859_1_s . '&';
				} else {
					$iso_8859_1_s = $iso_8859_1_s .
					  decodeBASE64(substr($b64_s, 1));
				}
				$b64_s = '';
			} else {
				$b64_s = $b64_s . $c;
			}
		} else {
			if ($c == '&') {
				$b64_s = '&';
			} else {
				$iso_8859_1_s = $iso_8859_1_s . $c;
			}
		}
	}
	return $iso_8859_1_s;
}

function find_mailbox_name ($mailbox) {
    if (ereg(" *\"([^\r\n\"]*)\"[ \r\n]*$", $mailbox, $regs))
        return $regs[1];
    ereg(" *([^ \r\n\"]*)[ \r\n]*$",$mailbox,$regs);
    return $regs[1];
    
}

/**
 * If $haystack is a full mailbox name, and $needle is the mailbox
 * separator character, returns the second last part of the full
 * mailbox name (i.e. the mailbox's parent mailbox)
 */
function readMailboxParent($haystack, $needle) {

    if ($needle == '') {
        $ret = '';
    } else {
        $parts = explode($needle, $haystack);
        $elem = array_pop($parts);
        while ($elem == '' && count($parts)) {
            $elem = array_pop($parts);
        }
        $ret = join($needle, $parts);
    }
    return( $ret );
}


function isBoxBelow( $box2, $box1 ) {
    global $delimiter, $folder_prefix, $imap_server_type;

    if ( $imap_server_type == 'uw' ) {
        $boxs = $box2;
        $i = strpos( $box1, $delimiter, strlen( $folder_prefix ) );
        if ( $i === false ) {
            $i = strlen( $box2 );
        }
    } else {
        $boxs = $box2 . $delimiter;
        /* Skip next second delimiter */
        $i = strpos( $box1, $delimiter );
        $i = strpos( $box1, $delimiter, $i + 1  );
        if ( $i === false ) {
            $i = strlen( $box2 );
        } else {
            $i++;
        }
    }

    return ( substr( $box1, 0, $i ) == substr( $boxs, 0, $i ) );
}

/* Defines special mailboxes */
function isSpecialMailbox( $box ) {
    global $trash_folder, $sent_folder, $draft_folder,
           $move_to_trash, $move_to_sent, $save_as_draft;

    $ret = ( (strtolower($box) == 'inbox') ||
             ( $move_to_trash && isBoxBelow( $box, $trash_folder ) ) ||
             ( $move_to_sent && isBoxBelow( $box, $sent_folder )) ||
             ($save_as_draft && $box == $draft_folder ) );

    if ( !$ret ) {
        $ret = do_hook_function( 'special_mailbox', $box );
    }

    return $ret;
}

/* Expunges a mailbox */
function sqimap_mailbox_expunge ($imap_stream, $mailbox, $handle_errors = true) {
    $read = sqimap_run_command($imap_stream, 'EXPUNGE', $handle_errors,
                               $response, $message);
}

/* Checks whether or not the specified mailbox exists */
function sqimap_mailbox_exists ($imap_stream, $mailbox) {
    if (! isset($mailbox)) {
        return false;
    }
    $mbx = sqimap_run_command($imap_stream, "LIST \"\" \"$mailbox\"",
                              true, $response, $message);
    return isset($mbx[0]);
}

/* Selects a mailbox */
function sqimap_mailbox_select ($imap_stream, $mailbox,
                                $hide = true, $recent = false, $extrainfo = false) {
    global $auto_expunge;

    if ( $mailbox == 'None' ) {
        return;
    }

    $read = sqimap_run_command($imap_stream, "SELECT \"$mailbox\"",
                               true, $response, $message);
    if ($recent) {
        for ($i=0; $i<count($read); $i++) {
            if (strpos(strtolower($read[$i]), 'recent')) {
                $r = explode(' ', $read[$i]);
            }
        }
        return $r[1];
    } else {
        if ($auto_expunge) {
            $tmp = sqimap_run_command($imap_stream, 'EXPUNGE', false, $a, $b);
        }
        if (isset( $extrainfo ) && $extrainfo) {
            $result = array();
            for ($i=0; $i<count($read); $i++) {
                if (preg_match("/PERMANENTFLAGS(.*)/i",$read[$i], $regs)) {
                    $regs[1]=trim(preg_replace (  array ("/\(/","/\)/","/\]/") ,'', $regs[1])) ;
                    $result['PERMANENTFLAGS'] = $regs[1];
                }
                else if (preg_match("/FLAGS(.*)/i",$read[$i], $regs)) {
                    $regs[1]=trim(preg_replace (  array ("/\(/","/\)/") ,'', $regs[1])) ;
                    $result['FLAGS'] = $regs[1];
                }
                else if (preg_match("/(.*)EXISTS/i",$read[$i], $regs)) {
                    $result['EXISTS']=trim($regs[1]);
                }
                else if (preg_match("/(.*)RECENT/i",$read[$i], $regs)) {
                    $result['RECENT']=trim($regs[1]);
                }
                else if (preg_match("/\[UNSEEN(.*)\]/i",$read[$i], $regs)) {
                    $result['UNSEEN']=trim($regs[1]);
                }

            }
            return( $result );
        }
    }
}

/* Creates a folder */
function sqimap_mailbox_create ($imap_stream, $mailbox, $type) {
    global $delimiter;
    if (strtolower($type) == 'noselect') {
        $mailbox .= $delimiter;
    }
    $read_ary = sqimap_run_command($imap_stream, "CREATE \"$mailbox\"",
                                   true, $response, $message);
    sqimap_subscribe ($imap_stream, $mailbox);
}

/* Subscribes to an existing folder */
function sqimap_subscribe ($imap_stream, $mailbox) {
    $read_ary = sqimap_run_command($imap_stream, "SUBSCRIBE \"$mailbox\"",
                                   true, $response, $message);
}

/* Unsubscribes to an existing folder */
function sqimap_unsubscribe ($imap_stream, $mailbox) {
    global $imap_server_type;
    $read_ary = sqimap_run_command($imap_stream, "UNSUBSCRIBE \"$mailbox\"",
                                   true, $response, $message);
}

/* Deletes the given folder */
function sqimap_mailbox_delete ($imap_stream, $mailbox) {
    global $data_dir, $username;
    $read_ary = sqimap_run_command($imap_stream, "DELETE \"$mailbox\"",
                                   true, $response, $message);
    sqimap_unsubscribe ($imap_stream, $mailbox);
    do_hook_function("rename_or_delete_folder", $args = array($mailbox, 'delete', ''));
    removePref($data_dir, $username, "thread_$mailbox");
}

function sqimap_mailbox_mydelete ($imap_stream, $mailbox) {
    global $data_dir, $username;
    $read_ary = sqimap_run_command($imap_stream, "DELETE \"$mailbox\"",
                                   true, $response, $message);
    sqimap_unsubscribe ($imap_stream, $mailbox);
}

/* Determines if the user is subscribed to the folder or not */
function sqimap_mailbox_is_subscribed($imap_stream, $folder) {
    $boxesall = sqimap_mailbox_list ($imap_stream);
    foreach ($boxesall as $ref) {
        if ($ref['unformatted'] == $folder) {
            return true;
        }
    }
    return false;
}

/* Renames a mailbox */
function sqimap_mailbox_rename( $imap_stream, $old_name, $new_name ) {
    if ( $old_name != $new_name ) {
        global $delimiter, $imap_server_type, $data_dir, $username;
        if ( substr( $old_name, -1 ) == $delimiter  ) {
            $old_name = substr( $old_name, 0, strlen( $old_name ) - 1 );
            $new_name = substr( $new_name, 0, strlen( $new_name ) - 1 );
            $postfix = $delimiter;
        } else {
            $postfix = '';
        }
        $boxesall = sqimap_mailbox_list($imap_stream);
        $cmd = 'RENAME "' . quoteIMAP($old_name) . '" "' .  quoteIMAP($new_name) . '"';
        $data = sqimap_run_command($imap_stream, $cmd, true, $response, $message);
        sqimap_unsubscribe($imap_stream, $old_name.$postfix);
        $oldpref = getPref($data_dir, $username, "thread_".$old_name.$postfix);
        removePref($data_dir, $username, "thread_".$old_name.$postfix);
        sqimap_subscribe($imap_stream, $new_name.$postfix);
        setPref($data_dir, $username, "thread_".$new_name.$postfix, $oldpref);
        do_hook_function("rename_or_delete_folder",$args = array($old_name, 'rename', $new_name));
        $l = strlen( $old_name ) + 1;
        $p = 'unformatted';
        foreach ( $boxesall as $box ) {
            if ( substr( $box[$p], 0, $l ) == $old_name . $delimiter ) {
                $new_sub = $new_name . $delimiter . substr($box[$p], $l);
                if ($imap_server_type == 'cyrus') {
                    $cmd = 'RENAME "' . quoteIMAP($box[$p]) . '" "' .  quoteIMAP($new_sub) . '"';
                    $data = sqimap_run_command($imap_stream, $cmd, true,
                                               $response, $message);
                }
                sqimap_unsubscribe($imap_stream, $box[$p]);
                $oldpref = getPref($data_dir, $username, "thread_".$box[$p]);
                removePref($data_dir, $username, "thread_".$box[$p]);
                sqimap_subscribe($imap_stream, $new_sub);
                setPref($data_dir, $username, "thread_".$new_sub, $oldpref);
                do_hook_function("rename_or_delete_folder",
                                 $args = array($box[$p], 'rename', $new_sub));
            }
        }
    }
}

function sqimap_mailbox_myrename( $imap_stream, $old_name, $new_name ) {
    if ( $old_name != $new_name ) {
        global $delimiter, $imap_server_type;
        
        $postfix = '';
        $boxesall = sqimap_mailbox_list($imap_stream);
        $cmd = 'RENAME "' . quoteIMAP($old_name) . '" "' .  quoteIMAP($new_name) . '"';
        $data = sqimap_run_command($imap_stream, $cmd, true, $response, $message);
        sqimap_unsubscribe($imap_stream, $old_name.$postfix);
        sqimap_subscribe($imap_stream, $new_name.$postfix);

        $l = strlen( $old_name ) + 1;
        $p = 'unformatted';
        foreach ( $boxesall as $box ) {
            if ( substr( $box[$p], 0, $l ) == $old_name . $delimiter ) {
                $new_sub = $new_name . $delimiter . substr($box[$p], $l);
                if ($imap_server_type == 'cyrus') {
                    $cmd = 'RENAME "' . quoteIMAP($box[$p]) . '" "' .  quoteIMAP($new_sub) . '"';
                    $data = sqimap_run_command($imap_stream, $cmd, true,
                                               $response, $message);
                }
                sqimap_unsubscribe($imap_stream, $box[$p]);
                sqimap_subscribe($imap_stream, $new_sub);
            }
        }
    }
}

/*
 * Formats a mailbox into 4 parts for the $boxesall array
 *
 * The four parts are:
 *
 *     raw            - Raw LIST/LSUB response from the IMAP server
 *     formatted      - nicely formatted folder name
 *     unformatted    - unformatted, but with delimiter at end removed
 *     unformatted-dm - folder name as it appears in raw response
 *     unformatted-disp - unformatted without $folder_prefix
 */
function sqimap_mailbox_parse ($line, $line_lsub) {

    global $delimiter;
    $folder_prefix = "";

    /* Process each folder line */
    for ($g=0; $g < count($line); $g++) {

        /* Store the raw IMAP reply */
        if (isset($line[$g])) {
            $boxesall[$g]["raw"] = $line[$g];
        }
        else {
            $boxesall[$g]["raw"] = '';
        }


        /* Count number of delimiters ($delimiter) in folder name */
        $mailbox = trim($line_lsub[$g]);
        $dm_count =  substr_count($mailbox, $delimiter);
        if (substr($mailbox, -1) == $delimiter) {
            /* If name ends in delimiter, decrement count by one */
            $dm_count--;
        }

        /* Format folder name, but only if it's a INBOX.* or has a parent. */
        $boxesallbyname[$mailbox] = $g;
        $parentfolder = readMailboxParent($mailbox, $delimiter);
        if ( (strtolower(substr($mailbox, 0, 5)) == "inbox") ||
             (substr($mailbox, 0, strlen($folder_prefix)) == $folder_prefix) ||
             ( isset($boxesallbyname[$parentfolder]) &&
               (strlen($parentfolder) > 0) ) ) {
/*
            $indent = $dm_count - ( substr_count($folder_prefix, $delimiter));
            if ($indent > 0) {
                $boxesall[$g]['formatted']  = str_repeat('&nbsp;&nbsp;', $indent);
            }
            else {
*/
                $boxesall[$g]['formatted'] = '';
/*
            }
*/
            $boxesall[$g]['formatted'] .= readShortMailboxName($mailbox, $delimiter);
        }
        else {
            $boxesall[$g]['formatted']  = $mailbox;
        }

        $boxesall[$g]['unformatted-dm'] = $mailbox;
        if (substr($mailbox, -1) == $delimiter) {
            $mailbox = substr($mailbox, 0, strlen($mailbox) - 1);
        }
        $boxesall[$g]['unformatted'] = $mailbox;
        if (substr($mailbox,0,strlen($folder_prefix))==$folder_prefix) {
            $mailbox = substr($mailbox, strlen($folder_prefix));
        }
        $boxesall[$g]['unformatted-disp'] = $mailbox;
        $boxesall[$g]['id'] = $g;

        $boxesall[$g]['flags'] = array();
        if (isset($line[$g])) {
            ereg("\(([^)]*)\)",$line[$g],$regs);
            $flags = trim(strtolower(str_replace('\\', '',$regs[1])));
            if ($flags) {
                $boxesall[$g]['flags'] = explode(' ', $flags);
            }
        }
    }

    return $boxesall;
}

/*
 * Sorting function used to sort mailbox names.
 *     + Original patch from dave_michmerhuizen@yahoo.com
 *     + Allows case insensitivity when sorting folders
 *     + Takes care of the delimiter being sorted to the end, causing
 *       subfolders to be listed in below folders that are prefixed
 *       with their parent folders name.
 *
 *       For example: INBOX.foo, INBOX.foobar, and INBOX.foo.bar
 *       Without special sort function: foobar between foo and foo.bar
 *       With special sort function: foobar AFTER foo and foo.bar :)
 */
function user_strcasecmp($a, $b) {

    global $delimiter;

    /* Calculate the length of some strings. */
    $a_length = strlen($a);
    $b_length = strlen($b);
    $min_length = min($a_length, $b_length);
    $delimiter_length = strlen($delimiter);

    /* Set the initial result value. */
    $result = 0;

    /* Check the strings... */
    for ($c = 0; $c < $min_length; ++$c) {
        $a_del = substr($a, $c, $delimiter_length);
        $b_del = substr($b, $c, $delimiter_length);

        if (($a_del == $delimiter) && ($b_del == $delimiter)) {
            $result = 0;
        } else if (($a_del == $delimiter) && ($b_del != $delimiter)) {
            $result = -1;
        } else if (($a_del != $delimiter) && ($b_del == $delimiter)) {
            $result = 1;
        } else {
            $result = strcasecmp($a{$c}, $b{$c});
        }

        if ($result != 0) {
            break;
        }
    }

    /* If one string is a prefix of the other... */
    if ($result == 0) {
        if ($a_length < $b_length) {
            $result = -1;
        } else if ($a_length > $b_length) {
            $result = 1;
        }
    }

    return $result;
}


/*
 * Returns sorted mailbox lists in several different ways. 
 * See comment on sqimap_mailbox_parse() for info about the returned array.
 */
function sqimap_mailbox_list($imap_stream) {

    $default_folder_prefix = "";
    $folder_prefix = "";
    $list_special_folders_first = 0;

        global $delimiter,$imap_list_all;
        
        $inbox_in_list = false;
        $inbox_subscribed = false;

        /* LSUB array */

		if ($imap_list_all) {
          $cmd = "LIST \"$folder_prefix\" \"*\"";
		} else {
        $cmd = "LSUB \"$folder_prefix\" \"*\"";
		}

        $lsub_ary = sqimap_run_command ($imap_stream, $cmd,
                                        true, $response, $message);

        /*
         * Section about removing the last element was removed 
         * We don't return "* OK" anymore from sqimap_read_data
         */

        $sorted_lsub_ary = array();
        for ($i=0;$i < count($lsub_ary); $i++) {
            /*
             * Workaround for EIMS
             * Doesn't work if the mailbox name is multiple lines
             */
            if (isset($lsub_ary[$i + 1]) &&
                ereg("^(\\* [A-Z]+.*)\\{[0-9]+\\}([ \n\r\t]*)$",
                     $lsub_ary[$i], $regs)) {
                $i ++;
                $lsub_ary[$i] = $regs[1] . '"' . addslashes(trim($lsub_ary[$i])) . '"' . $regs[2];
            }
            $temp_mailbox_name = find_mailbox_name($lsub_ary[$i]);
            $sorted_lsub_ary[] = $temp_mailbox_name;
            if (strtoupper($temp_mailbox_name) == 'INBOX') {
                $inbox_subscribed = true;
            }
        }

        $new_ary = array();
        for ($i=0; $i < count($sorted_lsub_ary); $i++) {
            if (!in_array($sorted_lsub_ary[$i], $new_ary)) {
                $new_ary[] = $sorted_lsub_ary[$i];
            }
        }
		
        $sorted_lsub_ary = $new_ary;
        if (isset($sorted_lsub_ary)) {
            usort($sorted_lsub_ary, 'user_strcasecmp');
        }

        /* LIST array */
        $sorted_list_ary = array();
        for ($i=0; $i < count($sorted_lsub_ary); $i++) {
            if (substr($sorted_lsub_ary[$i], -1) == $delimiter) {
                $mbx = substr($sorted_lsub_ary[$i], 0, strlen($sorted_lsub_ary[$i])-1);
            } else {
                $mbx = $sorted_lsub_ary[$i];
            }

			/*
            $read = sqimap_run_command ($imap_stream, "LIST \"\" \"$mbx\"",
                                        true, $response, $message);
            if (isset($read[1]) &&
                ereg("^(\\* [A-Z]+.*)\\{[0-9]+\\}([ \n\r\t]*)$",
                     $read[0], $regs)) {
                $read[0] = $regs[1] . '"' . addslashes(trim($read[1])) . '"' . $regs[2];
            }

            if (isset($sorted_list_ary[$i])) {
                $sorted_list_ary[$i] = '';
            }

            if (isset($read[0])) {
                $sorted_list_ary[$i] = $read[0];
            } else {
                $sorted_list_ary[$i] = '';
            }
//            if (isset($sorted_list_ary[$i]) && strtoupper(find_mailbox_name($sorted_list_ary[$i])) == 'INBOX') {
			*/
            if (strtoupper(find_mailbox_name($sorted_lsub_ary[$i])) == 'INBOX') {
                $inbox_in_list = true;
            }
        }

        /*
         * Just in case they're not subscribed to their inbox,
         * we'll get it for them anyway
         */
        if (!$inbox_subscribed || !$inbox_in_list) {
            $inbox_ary = sqimap_run_command ($imap_stream, "LIST \"\" \"INBOX\"",
                                             true, $response, $message);

            if (isset($inbox_ary[1]) &&
                ereg("^(\\* [A-Z]+.*)\\{[0-9]+\\}([ \n\r\t]*)$",
                     $inbox_ary[0], $regs)) {
                $inbox_ary[0] = $regs[1] . '"' . addslashes(trim($inbox_ary[1])) .
                    '"' . $regs[2];
            }

            $sorted_list_ary[] = $inbox_ary[0];
            $sorted_lsub_ary[] = find_mailbox_name($inbox_ary[0]);
        }

        $boxesall = sqimap_mailbox_parse ($sorted_lsub_ary, $sorted_lsub_ary);
        $boxesnew = array();
        $boxesnew2 = array();
        $boxesnew3 = array();
        foreach ( $boxesall as $k => $box ) {
            if ( strtolower($box['unformatted']) == 'inbox' or strtolower($box['unformatted']) == 'trash' or strtolower($box['unformatted']) == 'sent' or strtolower($box['unformatted']) == 'drafts' or strtolower($box['unformatted']) == 'spam'
			   or strtolower($box['unformatted']) == 'inbox'.$delimiter.'trash' or strtolower($box['unformatted']) == 'inbox'.$delimiter.'sent' or strtolower($box['unformatted']) == 'inbox'.$delimiter.'drafts' or strtolower($box['unformatted']) == 'inbox'.$delimiter.'spam'
			) {
                $boxesnew[] = $box;
				unset($boxesall[$k]);
            }
        }

		foreach ($boxesnew as $k => $box ) {
		  if ( strtolower($box['unformatted']) == 'inbox' ) {
            $boxesnew2[] = $box;
			unset($boxesnew[$k]);
          }
        }
                 
		foreach ($boxesnew as $k => $box ) {
		  if ( strtolower($box['formatted']) != 'spam' and strtolower($box['unformatted']) != 'inbox') {
            $boxesnew2[] = $box;
			unset($boxesnew[$k]);
          }
        }

		$boxesnew = array_merge($boxesnew2,$boxesnew,$boxesall);

    return $boxesnew;
}

function ary_sort($ary,$col, $dir = 1)
{
    /* The globals are used because USORT determines what is passed to comp2 */
    /* These should be $this->col and $this->dir in a class */
    /* Would beat using globals */
    if (!is_array($col)) {
        $col = array($col);
    }
    $GLOBALS['col'] = $col;  /* Column or Columns as an array */
    if ($dir > 0) {
        $dir = 1;
    }
    else {
        $dir = -1;
    }
    /* Direction, a positive number for ascending a negative for descending */
    $GLOBALS['dir'] = $dir;

    usort($ary,'array_comp2');
    return $ary;
}

function array_comp2($a,$b,$i = 0)
{
    global $col;
    global $dir;
    $c = count($col) -1;
    if ($a[$col[$i]] == $b[$col[$i]]) {
        $r = 0;
        while ($i < $c && $r == 0) {
            $i++;
            $r = comp2($a,$b,$i);
        }
    }
    elseif ($a[$col[$i]] < $b[$col[$i]]) {
        return (- $dir);
    } 
    return $dir;
}

/**
 * If $haystack is a full mailbox name and $needle is the mailbox
 * separator character, returns the last part of the mailbox name.
 */
function readshortmailboxname($haystack, $needle) {

    if ($needle == '') {
        $elem = $haystack;
    } else {
	    $parts = explode($needle, $haystack);
	    $elem = array_pop($parts);
	    while ($elem == '' && count($parts)) {
	        $elem = array_pop($parts);
	    }
    }
    return( $elem );
}

/*
 *  Returns a list of all folders, subscribed or not
 */
function sqimap_mailbox_list_all($imap_stream) {

    global $delimiter;
    $folder_prefix = "";

    $ssid = sqimap_session_id();
    $lsid = strlen( $ssid );
    $cmd = "LSUB \"$folder_prefix\" \"*\"";
    
    $read_ary = sqimap_run_command ($imap_stream, $cmd, true, $response, $message);

    $g = 0;
    $phase = 'inbox';

    for ($i = 0; $i < count($read_ary); $i++) {
        /* Another workaround for EIMS */
        if (isset($read_ary[$i + 1]) &&
            ereg("^(\\* [A-Z]+.*)\\{[0-9]+\\}([ \n\r\t]*)$",
                 $read_ary[$i], $regs)) {
            $i ++;
            $read_ary[$i] = $regs[1] . '"' . addslashes(trim($read_ary[$i])) . '"' . $regs[2];
        }
        if (substr($read_ary[$i], 0, $lsid) != $ssid ) {

            /* Store the raw IMAP reply */
            $boxes[$g]['raw'] = $read_ary[$i];

            /* Count number of delimiters ($delimiter) in folder name */
            $mailbox = find_mailbox_name($read_ary[$i]);
            $dm_count =  substr_count($mailbox, $delimiter);
            if (substr($mailbox, -1) == $delimiter) {
                /* If name ends in delimiter - decrement count by one */
                $dm_count--;
            }

            /* Format folder name, but only if it's a INBOX.* or has a parent. */
            $boxesallbyname[$mailbox] = $g;
            $parentfolder = readMailboxParent($mailbox, $delimiter);
            if((eregi('^inbox'.quotemeta($delimiter), $mailbox)) ||
               (ereg('^'.$folder_prefix, $mailbox)) ||
               ( isset($boxesallbyname[$parentfolder]) && (strlen($parentfolder) > 0) ) ) {
/*
                if ($dm_count) {
                    $boxes[$g]['formatted']  = str_repeat('&nbsp;&nbsp;', $dm_count);
                }
                else {
*/
                    $boxes[$g]['formatted'] = '';
/*
                }
*/
                $boxes[$g]['formatted'] .= readShortMailboxName($mailbox, $delimiter);
            }
            else {
                $boxes[$g]['formatted']  = $mailbox;
            }

            $boxes[$g]['unformatted-dm'] = $mailbox;
            
            if (substr($mailbox, -1) == $delimiter) {
                $mailbox = substr($mailbox, 0, strlen($mailbox) - 1);
            }
            $boxes[$g]['unformatted'] = $mailbox;
            $boxes[$g]['unformatted-disp'] = ereg_replace('^' . $folder_prefix, '', $mailbox);
            $boxes[$g]['id'] = $g;

            /* Now lets get the flags for this mailbox */
            $read_mlbx = sqimap_run_command ($imap_stream, "LIST \"\" \"$mailbox\"",
                                             true, $response, $message);

            /* Another workaround for EIMS */
            if (isset($read_mlbx[1]) &&
                ereg("^(\\* [A-Z]+.*)\\{[0-9]+\\}([ \n\r\t]*)$", $read_mlbx[0], $regs)) {
                $read_mlbx[0] = $regs[1] . '"' . addslashes(trim($read_mlbx[1])) . '"' . $regs[2];
            }

            $flags = substr($read_mlbx[0], strpos($read_mlbx[0], '(')+1);
            $flags = substr($flags, 0, strpos($flags, ')'));
            $flags = str_replace('\\', '', $flags);
            $flags = trim(strtolower($flags));
            if ($flags) {
                $boxes[$g]['flags'] = explode(' ', $flags);
            } else {
                $boxes[$g]['flags'] = array();
            }
        }
        $g++;
    }
    if(is_array($boxes)) {
        $boxes = ary_sort ($boxes, 'unformatted', 1);
    }

    return $boxes;
}

?>
